import {scene} from "./mario.js";

export class Personnage{
    constructor(x, y, largeur, hauteur){
        this.x = x;
        this.y = y;
        this.largeur = largeur;
        this.hauteur = hauteur;
        this.compteur = 0; 
        this.enMarche = false;
        this.versDroite = true;
    }

    marche(nom, frequence){
        let str = "";
        this.img = new Image();

        if(this.enMarche === false || scene.xPos <= 0){
            if(this.versDroite === true){
                str = "../images/"+nom+"ArretDroite.png";
            }else{
                str = "../images/"+nom+"ArretGauche.png";
            }
        }else{
            this.compteur++;
            if(this.compteur % frequence <= frequence/2){
                if(this.versDroite === true){
                    str = "../images/"+nom+"MarcheDroite.png";
                }else{
                    str = "../images/"+nom+"MarcheGauche.png";
                }
            }else{
                if(this.versDroite === true){
                    str = "../images/"+nom+"ArretDroite.png";
                }else{
                    str = "../images/"+nom+"ArretGauche.png";
                }
            }
            if(this.compteur === 2*frequence){
                this.compteur = 0;
            }
        }
        this.img.src = str;
        return this.img;
    }
}

export class Mario extends Personnage{
    constructor(x, y){
        super(x, y, 28, 50);
        this.imgMario = new Image();
        this.imgMario.src = "../images/marioArretDroite.png";
        this.saut = false;
        this.compteurSaut = 0;
    }

    saute(){
        let str = "";
        this.img = new Image();
        this.compteurSaut++;
        // Montée du saut
        if(this.compteurSaut <= 35){
            if(this.y > 0){this.y = this.y - 4;}
            else{this.compteur = 36;}
            if(this.versDroite === true){str = "../images/marioSautDroite.png";}
            else{str = "../images/marioSautGauche.png";}
        // Retombée du saut
        }else if(this.y + this.hauteur < scene.ySol){
            this.y = this.y + 1;
            if(this.versDroite === true){str = "../images/marioSautDroite.png";}
            else{str = "../images/marioSautGauche.png";}
        // Saut terminé
        }else{
            this.saut = false;
            this.compteurSaut = 0;
            if(this.versDroite === true){str = "../images/marioArretDroite.png";}
            else{str = "../images/marioArretGauche.png";}
        }
        this.img.src = str;
        return this.img;
    }
}